=== debian/changelog ===
gmsh (4.1.3+ds1-1) unstable; urgency=medium

  * [dbbbe82] New upstream version 4.1.3+ds1
  * [df49b2c6] Update packaging for Gmsh 4.1

 -- Kurt Kremitzki <kurt@kwk.systems>  Sun, 27 Jan 2019 05:22:01 -0600
