=== debian/changelog ===
gmsh (4.1.5+ds1-2) unstable; urgency=medium

  * [aea930a] Add patch to fix immintrin.h build failure

 -- Kurt Kremitzki <kurt@kwk.systems>  Mon, 04 Mar 2019 07:34:34 -0600

gmsh (4.1.5+ds1-1) unstable; urgency=medium

  [ Nico Schlömer ]
  * [f7d07307] New upstream version 4.1.5+ds1
  * [18426009] Add Metis support
  * [eb1e5c3f] Remove MPI, enable OpenMP
  * [9e1bff41,11ed9f54] Remove unused dependencies
  * [2d00240b] update metadata

  [ Kurt Kremitzki ]
  * [3556b0a] Update OpenCASCADE path
  * [fcc2d0c] Re-add python-gmsh package

 -- Kurt Kremitzki <kurt@kwk.systems>  Fri, 01 Mar 2019 22:50:39 -0600
