=== debian/rules ===
--- 
+++ 
@@ -8,45 +8,38 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python3
+	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)
 
-export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
+disable_auto_test_archs = mips64el
+export LD_LIBRARY_PATH := $(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH);
 
-disable_mpi_archs = kfreebsd-amd64 kfreebsd-i386 ia64
-disable_auto_test_archs = mips64el
-export LD_LIBRARY_PATH :=  $(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH);
-
+# TODO remove -DENABLE_OCC_CAF:BOOL=ONE once
+# <https://gitlab.onelab.info/gmsh/gmsh/issues/504> is resolved.
+#
+# Turn off PETSc support. We would need to use an MPI compiler (which isn't really
+# recommended), and all functionality is present without PETSc as well. See
+# <https://gitlab.onelab.info/gmsh/gmsh/issues/502#note_6599>.
+#
+# Turn off MED support for now. All the dependencies are there in Debian
+# (libhdf5-serial-dev, libmed-dev, libmedc-dev), but libmed is provided
+# MPI-compiled only, leading to errors as described in
+# <https://gitlab.onelab.info/gmsh/gmsh/issues/504#note_6602>.
 extra_flags += \
--DENABLE_OS_SPECIFIC_INSTALL:BOOL=ON \
--DENABLE_SYSTEM_CONTRIB:BOOL=ON \
--DENABLE_METIS:BOOL=OFF \
--DENABLE_MED:BOOL=OFF \
--DENABLE_TAUCS:BOOL=OFF \
--DENABLE_OSMESA:BOOL=OFF \
--DENABLE_CGNS:BOOL=ON \
--DENABLE_OCC:BOOL=ON \
--DENABLE_OCC_CAF:BOOL=ON \
--DENABLE_WRAP_PYTHON:BOOL=ON \
--DENABLE_BUILD_SHARED:BOOL=ON \
--DENABLE_BUILD_DYNAMIC:BOOL=ON \
--DENABLE_ONELAB:BOOL=ON \
--DCMAKE_SKIP_RPATH:BOOL=ON \
--DCMAKE_INCLUDE_PATH:STRING="/usr/include/mpi" \
--DOCC_INC:STRING="/usr/include/occt" \
--DOCC_LIB:STRING="/usr/lib/${DEB_HOST_MULTIARCH}"                                                      │
-
-
-ifeq (,$(filter $(DEB_HOST_ARCH),$(disable_mpi_archs)))
-	extra_flags += \
-	-DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -lmpi -fPIC \
-	                   -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
-	-DENABLE_MPI:BOOL=ON
-else
-	extra_flags += \
-	-DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -fopenmp -fPIC \
-	                   -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
-	-DENABLE_MPI:BOOL=OFF
-endif
+    -DCMAKE_SKIP_RPATH:BOOL=ON \
+    -DENABLE_BUILD_SHARED:BOOL=ON \
+    -DENABLE_BUILD_DYNAMIC:BOOL=ON \
+    -DENABLE_OPENMP:BOOL=ON \
+    -DENABLE_OS_SPECIFIC_INSTALL:BOOL=ON \
+    -DENABLE_SYSTEM_CONTRIB:BOOL=ON \
+    -DENABLE_CGNS:BOOL=ON \
+    -DENABLE_MED:BOOL=OFF \
+    -DENABLE_METIS:BOOL=ON \
+    -DENABLE_OCC:BOOL=ON \
+    -DOCC_LIB:STRING="/usr/lib/${DEB_HOST_MULTIARCH}" \
+    -DENABLE_OCC_CAF:BOOL=ON \
+    -DENABLE_ONELAB:BOOL=ON \
+    -DENABLE_OSMESA:BOOL=OFF \
+    -DENABLE_PETSC:BOOL=OFF
 
 override_dh_auto_clean:
 	rm -rf $(BUILDDIR)
@@ -79,6 +72,7 @@
 	dh_installdocs --doc-main-package=gmsh-doc -pgmsh-doc
 	dh_installdocs --doc-main-package=gmsh-doc -plibgmsh-dev
 	dh_installdocs --doc-main-package=gmsh-doc -plibgmsh4.1
+	dh_installdocs --doc-main-package=gmsh-doc -ppython-gmsh
 	dh_installdocs --doc-main-package=gmsh-doc -ppython3-gmsh
 
 override_dh_auto_test:
